function [D] = initialize_D(dim_x,dim_alfa,constraint_D_id)
%Initialization of dictionary D.
%
%Arguments:
%   size of D      : 'dim_x' x 'dim_alfa',
%   constraint_D_id: constraint for dictionary D.

switch constraint_D_id
    case 0 %l_2 sphere (||d_j||_2=1)
        D = randn(dim_x,dim_alfa);
        D = D ./ repmat(sqrt(sum(D.^2)),[dim_x 1]);
    case 1 %non-negative l_2 sphere
        D = rand(dim_x,dim_alfa);  
        D = D ./ repmat(sqrt(sum(D.^2)),[dim_x 1]);
    case 2 %l_1 sphere
        D = randn(dim_x,dim_alfa);  
        D = projection_to_the_l1_sphere_matrix(D);
    case 3 %non-negative l_1 sphere        
        D = rand(dim_x,dim_alfa);  
        D = projection_to_the_nonneg_l1_sphere_matrix(D);        
    otherwise
        disp('Error: D constraint=?');
end    
