function [fstats] = initialize_fstats(dim_x,dim_alfa,method)
%Initialization of the statistics (fstats) decribing cost function \hat{f}(D).
%
%Arguments:
%   dim_x   : dimension of the observation.
%   dim_alfa: dimension of the hidden representation.
%   method  : method of D optimization, 'BCD' or 'BCDA'.

switch method
    case 'BCDA'
        fstats.E = zeros(dim_x,dim_alfa);
        fstats.C = zeros(dim_x,dim_alfa);
        fstats.B = zeros(dim_x,dim_alfa);
    case 'BCD'
        fstats.A = zeros(dim_alfa);
        fstats.B = zeros(dim_x,dim_alfa);
    otherwise 
        disp('Error: method=?');
end