function [neighs_alfa,num_of_neighs] = generate_toroid_alfa_neighs(dim_alfa_y,dim_alfa_x,neighbor_size)
%Generates the neighbors on a toroid with given parameters.
%
%Arguments:
% size of the toroid         : dim_alfa_y x dim_alfa_x,
% neighbor size on the toroid: neighbor_size.
%
%Output:
%   neighs_alfa(:,k) : neigbors of the k^th element,
%   num_of_neighs    : number of neighbors.

    adj_alfa = create_adj_toroid(dim_alfa_y,dim_alfa_x,neighbor_size);
    %k=1 (initialize num_of_neighs):
        nei = find(adj_alfa(:,1));
        num_of_neighs = length(nei);
        dim_alfa = dim_alfa_y * dim_alfa_x;
        neighs_alfa = zeros(num_of_neighs,dim_alfa);
        neighs_alfa(:,1) = nei;
        
    %k>1:
        for k = 2 : dim_alfa
            neighs_alfa(:,k) = find(adj_alfa(:,k));
        end
