function [D2] = plot_D_toroid(D,dim_alfa_y,dim_alfa_x,dim_x_1,dim_x_2,offset,size_of_edge)
%Illustrates dictionary D in case of toroid group structure.
%
%Arguments:
%   D: dictionary,
%   size of the toroid: dim_alfa_y x dim_alfa_x,
%   size of the d_j columns of D: dim_x_1 x dim_x_2,
%   offset: shift every second row with the value of this variable; can be used for 'toroid' imitation, see 'plot_D.m'
%   size_of_edge: separate d_js; =width of separation.

%parameters:
    scale_factor = min(min(D)); %"0", "1/2","min(min(D))"; has effect only in case of size_of_edge > 0
    
%initialize the "background" of D:
    D2 = scale_factor * ones(size_of_edge+(size_of_edge+dim_x_1)*dim_alfa_y,offset+size_of_edge+(size_of_edge+dim_x_2)*dim_alfa_x);
    
n = 0;
for k2 = 1 : dim_alfa_x
for k1 = 1 : dim_alfa_y        
        n = n + 1;
        iy2 = (size_of_edge+dim_x_1)*k1;
        iy1 = iy2-(dim_x_1-1);
        
        ix2 = (size_of_edge+dim_x_2)*k2;
        ix1 = ix2-(dim_x_2-1);
        if mod(k1,2)==1
            ix2 = ix2 + offset;
            ix1 = ix1 + offset;
        end
        D2(iy1:iy2,ix1:ix2) = reshape(D(:,n),[dim_x_1,dim_x_2]);
    end
end

imshow(D2,[]);
