function [v_projected] = projection_to_the_l1_sphere(v)
%Projects vector v to the l_1 sphere.

z = 1;%=radius of the sphere

if sum(abs(v)) <= z
    v_projected = v;
else
    d = length(v); 
    absv = abs(v);
    v_sorted = sort(absv,'descend');
    v_sorted_cumsummed_v2 = (cumsum(v_sorted)-z) ./ [1:d].';
    I = v_sorted > v_sorted_cumsummed_v2;
    ro = find(I,1,'last');
    theta = v_sorted_cumsummed_v2(ro);
    v_projected = sign(v) .* max(absv-theta,0);
end
